package com.elab.test.utils;

import com.google.common.base.Joiner;
import com.google.common.base.Preconditions;
import com.google.common.base.Splitter;
import com.google.common.collect.*;
import org.junit.Test;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * 工具类研究
 *
 * @author ： liukx
 * @time ： 2020/4/9 - 19:02
 */
public class GuavaUtilsCase {


    @Test
    public void ListTest() {
        // 普通集合
        ArrayList<Object> objects = Lists.newArrayList("a", "b", "c", "d", "e", "f");
        // 数据分片
        List<List<Object>> partition = Lists.partition(objects, 2);
        System.out.println("");

        String str = "1-2-3-4-5-6";
        List<String> list = Splitter.on("-").splitToList(str);
    }

    @Test
    public void MapTest() {
        /**
         * 允许一个key对应多个值，相当于Map<String,List<String>>
         */
        ArrayListMultimap<Object, Object> objectObjectArrayListMultimap = ArrayListMultimap.create();
        objectObjectArrayListMultimap.put("aaa", "a");
        objectObjectArrayListMultimap.put("aaa", "b");
        objectObjectArrayListMultimap.put("aaa", "c");
        System.out.println("===");

        HashBiMap<String, String> objectObjectHashBiMap = HashBiMap.create();
        objectObjectHashBiMap.put("a", "b");
        objectObjectHashBiMap.put("c", "d");
        objectObjectHashBiMap.put("e", "e");
        System.out.println("====");

        Table<String, String, Integer> tables = HashBasedTable.create();
        tables.put("l", "k", 1);

        Map<String, Integer> map = Maps.newHashMap();
        map.put("xiaoming", 12);
        map.put("xiaohong", 13);
        String result = Joiner.on(",").withKeyValueSeparator("=").join(map);

        String str = "xiaoming=11,xiaohong=23";
        Map<String, String> strMap = Splitter.on(",").withKeyValueSeparator("=").split(str);

        Preconditions.checkArgument(true, "asdfasdfd");
    }

    @Test
    public void strTest() {
        String text = "a,b,c,d";
        Joiner joiner1 = Joiner.on(",").skipNulls();
    }
}
